import subprocess
from typing import NamedTuple


class Command(NamedTuple):
    stdout: bytes
    stderr: bytes
    return_code: int


def run_command(command: str) -> Command:
    process = subprocess.Popen(
        command,
        stdout=subprocess.PIPE,
        stderr=subprocess.PIPE,
        stdin=subprocess.PIPE,
        shell=True,
    )
    stdout, stderr = process.communicate()
    return_code = process.returncode
    return Command(
        stdout,
        stderr,
        return_code,
    )
