import re
from typing import List

from .cmd import run_command


class Git:
    def get_log(self) -> List:
        command = "git log --first-parent --pretty=oneline -50"
        cmd = run_command(command=command)
        stdout = cmd.stdout.decode("utf-8")
        return [commit for commit in stdout.split("\n") if len(commit) > 0]

    def generate_commits_to_check(
        self,
        branch_list: List,
        initial_commit_msg: str = "Initial commit",
    ) -> List:
        commit_list = self.get_log()
        for commit in commit_list:
            merge_request = re.findall("Merge branch", commit)
            initial_commit = re.findall(f"{initial_commit_msg}", commit)
            if merge_request:
                for branch in branch_list:
                    branch_merge = re.findall(f"into '{branch}'$", commit)
                    if branch_merge:
                        index = commit_list.index(commit)
                        return commit_list[: (index + 1)]
            elif initial_commit:
                index = commit_list.index(commit)
                return commit_list[: (index + 1)]

    def get_branch_name(self):
        command = "git branch --show-current"
        cmd = run_command(command=command)
        branch_name = cmd.stdout.decode("utf-8")
        return branch_name.replace("\n", "")
